#pragma semicolon 1
#include <vip>

public Plugin:myinfo = 
{
	name = "[SWGM] VIP",
	author = "Someone / wS",
	version = "1.0.4"
};

#define SWGM_IN_GROUP	(1 << 0)
#define SWGM_VIP_GIVED	(1 << 1)

new String:g_VIPGroup[GROUP_LENGTH];
new g_Flags[MAXPLAYERS + 1];

public OnPluginStart()
{
	//
	new Handle:CVAR = CreateConVar("sm_swgm_vip_group", "Gold", "Участник стим группы (sm_swgm_groupid) временно добавляется в VIP группу (sm_swgm_vip_group)");
	GetConVarString(CVAR, g_VIPGroup, sizeof(g_VIPGroup));
	TrimString(g_VIPGroup);
	HookConVarChange(CVAR, CvarChanged);
	//
	
	VIP_HookEvent(VE_Authorized, VE_Authorized_);
	VIP_HookEvent(VE_Removed, VE_Removed_);
}

public CvarChanged(Handle:hCvar, const String:OldValue[], const String:NewValue[])
{
	strcopy(g_VIPGroup, sizeof(g_VIPGroup), NewValue);
	if (TrimString(g_VIPGroup) < 1 || !VIP_IsValidGroup(g_VIPGroup)) {
		g_VIPGroup[0] = 0;
	}
	for (new iClient = 1; iClient <= MaxClients; iClient++)
	{
		if ((g_Flags[iClient] & SWGM_VIP_GIVED) && IsClientInGame(iClient))
		{
			if (!g_VIPGroup[0] || !VIP_SetTemporaryGroup(iClient, g_VIPGroup))
			{
				g_Flags[iClient] &= ~SWGM_VIP_GIVED;
				VIP_UnSetTemporaryGroup(iClient);
			}
		}
	}
}

public SWGM_OnJoinGroup(iClient, bool:IsMember, bool:IsOfficer)
{
	if (IsMember && !(g_Flags[iClient] & SWGM_IN_GROUP))
	{
		g_Flags[iClient] |= SWGM_IN_GROUP;
		TryGiveVip(iClient);
	}
}

public SWGM_OnLeaveGroup(iClient)
{
	if (g_Flags[iClient] & SWGM_VIP_GIVED) {
		VIP_UnSetTemporaryGroup(iClient);
	}
	g_Flags[iClient] = 0;
}

//

public VE_Authorized_(iClient, const String:steamid[], bool:vip) { if (!vip) TryGiveVip(iClient); }
public VE_Removed_(iClient, const String:steamid[], const String:reason[]) { TryGiveVip(iClient); }

TryGiveVip(iClient)
{
	if (g_VIPGroup[0]
		&& (g_Flags[iClient] & SWGM_IN_GROUP)
		&& !(g_Flags[iClient] & SWGM_VIP_GIVED)
		&& !(VIP_GetFlags(iClient) & VCF_VIP)
		&& VIP_SetTemporaryGroup(iClient, g_VIPGroup))
	{
		g_Flags[iClient] |= SWGM_VIP_GIVED;
	}
}

//

public OnClientDisconnect(iClient) {
	g_Flags[iClient] = 0;
}